// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VExcelExport.pas' rev: 5.00

#ifndef VExcelExportHPP
#define VExcelExportHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VBaseExport.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vexcelexport
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TCellBorder { cbLeft, cbRight, cbTop, cbBottom };
#pragma option pop

typedef Set<TCellBorder, cbLeft, cbBottom>  TCellBorders;

#pragma option push -b-
enum TExcelColor { eclDefault, eclBlack, eclRed, eclGreen, eclBlue, eclYellow, eclCyan, eclMagenta, 
	eclWhite };
#pragma option pop

class DELPHICLASS TExcelOptions;
class PASCALIMPLEMENTATION TExcelOptions : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	AnsiString FPageFooter;
	AnsiString FPageHeader;
	Graphics::TFont* FDefaultFont;
	Graphics::TFont* FRowHeaderFont;
	TExcelColor FRowHeaderFontColor;
	void __fastcall SetPageFooter(const AnsiString Value);
	void __fastcall SetPageHeader(const AnsiString Value);
	void __fastcall SetDefaultFont(const Graphics::TFont* Value);
	void __fastcall SetRowHeaderFont(const Graphics::TFont* Value);
	void __fastcall SetRowHeaderFontColor(TExcelColor Value);
	
public:
	__fastcall TExcelOptions(void);
	__fastcall virtual ~TExcelOptions(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property AnsiString PageHeader = {read=FPageHeader, write=SetPageHeader};
	__property AnsiString PageFooter = {read=FPageFooter, write=SetPageFooter};
	__property Graphics::TFont* DefaultFont = {read=FDefaultFont, write=SetDefaultFont};
	__property Graphics::TFont* RowHeaderFont = {read=FRowHeaderFont, write=SetRowHeaderFont};
	__property TExcelColor RowHeaderFontColor = {read=FRowHeaderFontColor, write=SetRowHeaderFontColor, 
		default=0};
};


typedef void __fastcall (__closure *TGetExcelCellParamsEvent)(System::TObject* Sender, Db::TField* Field
	, bool ColHeader, TCellBorders Borders);

class DELPHICLASS TVExcelExport;
class PASCALIMPLEMENTATION TVExcelExport : public Vbaseexport::TVExport 
{
	typedef Vbaseexport::TVExport inherited;
	
private:
	Classes::TFileStream* Stream;
	TExcelOptions* FExcelOptions;
	Classes::TStrings* FColumnsWidth;
	TGetExcelCellParamsEvent FOnGetExcelCellParams;
	void __fastcall SetColumnsWidth(const Classes::TStrings* Value);
	void __fastcall SetExcelOptions(const TExcelOptions* Value);
	
protected:
	__property ColumnsCaptions ;
	virtual void __fastcall Abort(void);
	void __fastcall GetExcelCellParams(Db::TField* Field, bool ColHeader, TCellBorders Borders);
	
public:
	__fastcall virtual TVExcelExport(Classes::TComponent* AOwner);
	__fastcall virtual ~TVExcelExport(void);
	virtual bool __fastcall Execute(void);
	
__published:
	__property TExcelOptions* ExcelOptions = {read=FExcelOptions, write=SetExcelOptions};
	__property Classes::TStrings* ColumnsWidth = {read=FColumnsWidth, write=SetColumnsWidth};
	__property FileName ;
	__property Dataset ;
	__property UserFormats ;
	__property Formats ;
	__property Captions ;
	__property ShowFile ;
	__property ColHeaders ;
	__property Header ;
	__property Footer ;
	__property OnRecordExported ;
	__property OnBeginExport ;
	__property OnEndExport ;
	__property OnStopExport ;
	__property OnGetExportText ;
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TExcelColor __fastcall ColorToExcelColor(Graphics::TColor AColor);
extern PACKAGE Graphics::TColor __fastcall ExcelColorToColor(TExcelColor AColor, Graphics::TColor DefColor
	);

}	/* namespace Vexcelexport */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Vexcelexport;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VExcelExport
